<template>
  <div>
    <b-modal v-model="showModal" id="modal-center" hide-footer title="Registration">
      <div>
        <b-form>
          <b-form>
            <label class="mb-0">User ID</label>
            <b-form-text v-if="!isUserNameValid() && isAlreadyPushedSubmit">
              <span style="color: red">
                {{ typeOfErrorName }}
              </span>
            </b-form-text>
            <b-form-input v-model="form.username"
                          :disabled="isSubmitting"
                          placeholder="Enter the user"
            ></b-form-input>
            <b-form-text>
              Your user ID must be 5-20 characters long.
            </b-form-text>
          </b-form>

          <div class="mt-4">
            <b-form>
              <label class="mb-0">Password</label>
              <b-form-text v-if="!isPasswordValid() && isAlreadyPushedSubmit">
              <span style="color: red">
                {{ typeOfErrorPassword }}
              </span>
              </b-form-text>
              <b-form-input v-model="form.password"
                            placeholder="Enter the password"
                            :disabled="isSubmitting"
                            type="password" id="text-password"
                            aria-describedby="password-help-block"
              ></b-form-input>
              <b-form-text id="password-help-block">
                The password must be 5-20 characters long, contain letters and numbers
              </b-form-text>
            </b-form>
          </div>

          <div class="mt-3">
            <b-form>
              <label class="mb-0"> Repeat the password</label>
              <b-form-text v-if="!isRepeatPasswordValid() && isAlreadyPushedSubmit">
              <span style="color: red">
                {{ typeOfErrorRepeatPassword }}
              </span>
              </b-form-text>
              <b-form-input v-model="form.repeatPassword"
                            :disabled="isSubmitting"
                            placeholder="Repeat the password"
                            type="password" id="text-password"
                            aria-describedby="password-help-block"></b-form-input>
              <b-form-text id="password-help-block">
                Repeat the password
              </b-form-text>
            </b-form>
          </div>
          <div class="mt-5">
            <b-button class="mr-3" variant="primary" @click="onSubmit" v-if="!isSubmitting"
                      :disabled="isErrorName || isErrorPassword || isErrorRepeatPassword">Submit
            </b-button>
            <b-button class="mr-3" variant="primary" disabled v-if="isSubmitting">
              <b-spinner small type="grow"></b-spinner>
              Loading...
            </b-button>
            <b-button type="reset" variant="danger" :disabled="isSubmitting" @click="onReset">Reset</b-button>
          </div>
        </b-form>
        <b-form-text v-if="isErrorSubmitted">
              <span style="color: red">
                {{ typeOfErrorSubmitted }}
              </span>
        </b-form-text>
      </div>
    </b-modal>
  </div>
</template>

<script>
export default {
  name: 'Registration',
  data() {
    return {
      form: {
        username: '',
        password: '',
        repeatPassword: null,
      },
      formToSend: {
        username: '',
        password: ''
      },
      isAlreadyPushedSubmit: false,
      isErrorName: true,
      isErrorPassword: true,
      isErrorRepeatPassword: true,
      isErrorSubmitted: false,
      isSubmitting: false,
      showModal: false,
      typeOfErrorName: '',
      typeOfErrorPassword: '',
      typeOfErrorRepeatPassword: '',
      typeOfErrorSubmitted: ''
    }
  },
  methods: {
    isUserNameValid() {
      if (this.form.username.length < 5 || this.form.username.length > 20) {
        this.typeOfErrorName = 'Error: username not valid'
        this.isErrorName = true;
        return false;
      }
      this.isErrorName = false;
      return true;
    },
    isPasswordValid() {
      if (this.form.password.length < 5 || this.form.password.length > 20) {
        this.typeOfErrorPassword = 'Error: password not valid'
        this.isErrorPassword = true;
        return false;
      }
      this.isErrorPassword = false;
      return true;
    },
    isRepeatPasswordValid() {
      if (this.form.password !== this.form.repeatPassword) {
        this.typeOfErrorRepeatPassword = 'Error: the two password are not equal'
        this.isErrorRepeatPassword = true;
        return false;
      }
      this.isErrorRepeatPassword = false;
      return true;
    },
    onReset() {
      this.form.username = ''
      this.form.password = ''
      this.form.repeatPassword = ''
    },
    onSubmit() {
      this.isAlreadyPushedSubmit = true;
      this.isErrorSubmitted = false;
      if (this.isErrorName === false && this.isErrorPassword === false && this.isErrorRepeatPassword === false) {
        this.isSubmitting = true;
        this.formToSend.password = this.form.password;
        this.formToSend.username = this.form.username;
        this.$http.post('resource/registration-user', this.formToSend).then(
            () => {
              this.$swal.fire({
                title: 'Success!',
                text: 'The registration is done, now you have to login in order to become admin',
                icon: 'success',
                confirmButtonText: 'Cool'
              }).then(() => {
                this.onReset();
                this.showModal = false;
                this.isAlreadyPushedSubmit = false;
              });
            },
            (event) => {
              this.$swal.fire({
                title: 'Error!',
                text: 'Do you want to continue',
                icon: 'error',
                confirmButtonText: 'Cool'
              });
              this.isErrorSubmitted = true;
              switch (event.status) {
                case (400): {
                  this.typeOfErrorSubmitted = 'The data is not right, please verify them';
                  break;
                }
                case (409): {
                  this.typeOfErrorSubmitted = 'The username is already got, chose another one';
                  break;
                }
                case (500): {
                  this.typeOfErrorSubmitted = 'Server problem';
                  break;
                }
                default: {
                  this.typeOfErrorSubmitted = 'Server problem';
                }
              }
            }).then(() => {
          this.isSubmitting = false;
        });
      }
    },
    showModalAction() {
      this.showModal = true;
    }
  }
}
</script>
